import java.io.*;
import java.util.*;

/***************************************************************************
  Classe permettant d'ecrire dans le fichier passe en param au constructeur
****************************************************************************/

class Ecriture {
    protected BufferedWriter flot;
    
    // Constructeurs
    private Ecriture () { //On interdit de construire cet objet sans specifier le nom d'1 fichier
    }
    public Ecriture (String nomFichier) {
		try {
			// Necessaire pour ouvrir un fichier en ecriture
			FileOutputStream fic = new FileOutputStream(nomFichier);
			// Cree un flux bufferise vers ce fichier
			flot = new BufferedWriter(new OutputStreamWriter(fic));
		}
		catch (Exception e) {
			/* On se contente de signaler par un message qu'il y a eu une erreur
			   Si celle-ci n'est pas trop importe le programme peut continuer */
			System.out.println("Erreur a l'ouverture / creation du fichier " + nomFichier); 
		}
    }
    
    // Sauvegarde cat dans le fichier
    public void sauvegarde (Vector cat) throws IOException{
		String sTemp = ""; // On transforme cat en String dans stemp
		/* Rem l'ecriture bufferisee n'a pas grand interet ici */
		Fiche entree;
		// Traitement particulier pour la premiere  entree
		sTemp = sTemp + ((Fiche)cat.elementAt(0)).id + "\n";
		// Toutes les autres entrees sont traitees de la meme maniere
		for (int i=1; i<cat.size(); i++) {
			entree = (Fiche)cat.elementAt(i);
			sTemp = sTemp + entree.id + " \"" + entree.nom + "\"" + " \"" + entree.prenom + "\"";
			sTemp = sTemp + " " + entree.date.getDate() + " " + (entree.date.getMonth()+1) + " ";
			sTemp = sTemp + (entree.date.getYear()+1900) + " \"" + entree.voiture;
			sTemp = sTemp + "\" " + entree.prix + "\n";
		}
		// On ecrit dans le fichier
		flot.write(sTemp, 0, sTemp.length());
		System.out.println("Sauvegarde effectuee");
    }
    
    // Ferme le BufferedWriter
    public void ferme() throws IOException{
		flot.close();
    }
}