import java.io.*;
import java.util.*;
import java.lang.*;

class Interface{
    // Fichier par defaut pour stocker la base de donnees
    /* Rem: comme on ne travaille pas directement sur le fichier qui contient notre base de
       donnes, il faut faire attention  ne pas lancer plusieurs fois ce pgm en parallele
       sinon il risque d'y avoir des incoherences au niv du fichier de sauvegarde */
    private static String DEFAULT_FILE = "./catalogue.bdd";
    private static String curCatFile;
    private static Vector cat;
    private static boolean modif = false;

    public static void main (String arg[]) throws IOException, FileNotFoundException{
		// Ouverture du fichier de sauvegarde du catalogue
		// et chargement de celui dans le tableau de Vector cat
		if (arg.length == 0)
			curCatFile = DEFAULT_FILE;
		else if (arg.length == 1)
			curCatFile = arg[0];
		else {
			System.out.println("Cette application doit etre appelee avec au plus 1");
			System.out.println("argument qui correspond au fichier de sauvegarde ");
			System.out.println("du catalogue.");
			System.exit(0);
		}
		while (!ouverture()){
			// on retente une ouverture jusqu'a ce qu'elle reussisse
		}

		// Lancement de l'interface ligne de commande
		System.out.println("Bonjour");
		System.out.println("Tapez 'Help' ou 'h' pour obtenir de l'aide\n");
		Lecture lect;
		String [] cmd;
		boolean sortie = false;
		while (!sortie) {
			System.out.print("> ");
			// Interpretation de la ligne de commande
			cmd = StdIn.readLine();
			//for (int i=0; i<cmd.length; i++)
			//		System.out.println(cmd[i]);
			if (cmd[0].compareTo("quit")==0 || cmd[0].compareTo("q")==0) {
				if (modif) {
					String sTemp;
					boolean done = false;
					System.out.println("Voulez-vous quitter sans sauvegarder le catalogue ?");
					while (!done) {
						System.out.print(">[y=yes,n=no]> ");
						sTemp = StdIn.readWord();
						if (sTemp.compareTo("y")==0 || sTemp.compareTo("yes")==0) {
							sortie = true;
							done = true;
							System.out.println("Au revoir !");
						}
						else if (sTemp.compareTo("n")==0 || sTemp.compareTo("no")==0)
							done = true;
					}
				}
				else {
					System.out.println("Au revoir !");
					sortie = true;
				}
			}
			else if (cmd[0].compareTo("help")==0 || cmd[0].compareTo("h")==0)
				aide(cmd);
			else if (cmd[0].compareTo("add")==0 || cmd[0].compareTo("a")==0) 
				ajouter(cmd);
			else if (cmd[0].compareTo("search")==0 || cmd[0].compareTo("s")==0)
				rechercher(cmd);
			else if (cmd[0].compareTo("save")==0 || cmd[0].compareTo("S")==0)
				sauver(cmd);
			else {
				System.out.println("Commande inconnue");
				System.out.println("Taper 'help' ou 'h' pour obtenir de l'aide");
			}
		}
    }

    private static boolean ouverture () throws IOException{
		String sTemp;
		File fichier = new File(curCatFile);
		if (fichier.exists()) {
			if (!fichier.canRead()) {
				System.out.println("Vous ne pouvez pas ouvrir " + curCatFile);
				System.out.println("Voulez-vous ouvrir le fichier par defaut (catalogue.bdd)");
				System.out.println("ou voulez vous ouvrir un autre fichier ?");
				while (true){
					System.out.print(">[d=default,o=other]> ");
					sTemp  = StdIn.readWord();
					if (sTemp.compareTo("d")==0 || sTemp.compareTo("default")==0){
						curCatFile = DEFAULT_FILE;
						return false;
					}
					else if (sTemp.compareTo("o")==0 || sTemp.compareTo("other")==0) {
						System.out.println("Entrez le nom du fichier que vous voulez ouvrir");
						System.out.println("Par ex: \"../truc/mon fichier.bdd\"");
						System.out.println("        Fichier_sans_espace.bdd");
						System.out.print(">[name]> ");
						curCatFile = StdIn.readWord();
						return false;
					}
				}
			}
			else {
				if (fichier.length() == 0) {
					// Le fichier est vide. Ca ne sert a rien de l'ouvrir maintenant
					cat = new Vector();
					Fiche entree = new Fiche(1); // le 1er num de client non attribu est 1
					cat.addElement(entree);
				}
				else {
					Lecture lect = new Lecture(curCatFile);
					cat = lect.read();
					lect.ferme();
				}
				return true;
			}
		}
		else {
			System.out.println("Le fichier " + curCatFile + " n'existe pas !");
			System.out.println("Voulez-vous le creer, utiliser le fichier par defaut");
			System.out.println("(catalogue.bdd) ou entrer un autre nom de fichier ?");
			while (true) {
				System.out.print(">[c=create,d=default,o=other]> ");
				sTemp = StdIn.readWord();
				if (sTemp.compareTo("d")==0 || sTemp.compareTo("default")==0){
					curCatFile = DEFAULT_FILE;
					return false;
				}
				else if (sTemp.compareTo("o")==0 || sTemp.compareTo("other")==0) {
					System.out.println("Entrez le nom du fichier que vous voulez ouvrir");
					System.out.println("Par ex: \"../truc/mon fichier.bdd\"");
					System.out.println("        Fichier_sans_espace.bdd");
					System.out.print(">[name]> ");
					curCatFile = StdIn.readWord();
					return false;
				}
				else if (sTemp.compareTo("c")==0 || sTemp.compareTo("create")==0) {
					// On ne cree pas le fichier tt de suite, il sera cree lors
					// de la 1ere sauvegarde
					cat = new Vector();
					Fiche entree = new Fiche(1); // le 1er num de client non attribu est 1
					cat.addElement(entree);
					return true;
				}
			}
		}
    }

    private static void aide (String [] cmd){
		if (cmd.length == 1){
			System.out.println("'help'   ou 'h' => Aide");
			System.out.println("       '-cmd' => aide dtaille de cmd");
			System.out.println("'quit'   ou 'q' => Quitter");
			System.out.println("'add'    ou 'a' => Ajouter une nouvelle entree");
			System.out.println("'search' ou 's' => Lancer une recherche");
			System.out.println("'save'   ou 'S' => Sauvegarder le catalogue");
		}
		else if ( cmd.length == 2){
			if (cmd[1].compareTo("-search")==0 || cmd[1].compareTo("-s")==0) {
				System.out.println("Cette commande prend en 2eme argument:");  
				System.out.println("   -name  ou -n => infos sur un nom");  
				System.out.println("                   ex: s -n Dupond");
				System.out.println("   -first ou -f => infos sur un prenom");  
				System.out.println("                   ex: s -f \"Jean Pierre\"");
				System.out.println("   -id    ou -i => infos sur un numero de dossier");  
				System.out.println("                   ex: s -i 1235");
				System.out.println("   -date  ou -d => tous les achats entre 2 dates");  
				System.out.println("                   ex: s -d 31 12 1999 31 01 2000");
			}
			else if (cmd[1].compareTo("-help")==0 || cmd[1].compareTo("-h")==0) {
				System.out.println("Cette commande peut prendre en 2eme argument:");  
				System.out.println("   -<cmd>  ou -<c> => aide detaille sur cmd");
			}  
			else if (cmd[1].compareTo("-quit")==0 || cmd[1].compareTo("-q")==0) {
				System.out.println("Cette commande vous permet de quitter l'application.");
				System.out.println("Elle ne prend aucun argument.");  
			}
			else if (cmd[1].compareTo("-add")==0 || cmd[1].compareTo("-a")==0) {
				System.out.println("Cette commande lance un utilitaire pour vous guider.");
				System.out.println("Elle ne prend aucun argument.");  
			} 
			else if (cmd[1].compareTo("-save")==0 || cmd[1].compareTo("-S")==0) {
				System.out.println("Cette commande peut prendre en 2eme argument:");  
				System.out.println("   -<nom de fichier> => enregistre le catalogue ds le fichier specifie");
				System.out.println("Sans argument, l'enregistrement se fait dans le fichier d'ouverture");
			}  
			else { 
				System.out.println("Deuxieme argument inconnu.");
				System.out.println("Verifiez que la commande dont vous chercher");
				System.out.println("de l'aide existe bien.");
			}
		}
		else {
			System.out.println("Deuxieme argument inconnu.");
			System.out.println("Le 2eme argument doit etre du type:");
			System.out.println("         '-<Nom (entier ou abrege) de cmd>'");
		}
    }

    private static void rechercher (String [] cmd) {
		boolean done = false;
		String sTemp;
		int[] tabInt;
		if (cmd[1].compareTo("-n")==0 || cmd[1].compareTo("-name")==0) {
			rechercheNom(cmd);
		}
		else if (cmd[1].compareTo("-f")==0 || cmd[1].compareTo("-first")==0) {
			recherchePrenom(cmd);
		}
		else if (cmd[1].compareTo("-i")==0 || cmd[1].compareTo("-id")==0) {
			rechercheId(cmd);
		}
		else if (cmd[1].compareTo("-d")==0 || cmd[1].compareTo("-date")==0) {
			rechercheDate(cmd);
		}
		else {
			System.out.println("Deuxieme argument inconnu.");
			System.out.println("Taper 'h -s' pour obtenir de l'aide");
		}
    }

    private static void rechercheNom (String [] cmd) {
		if (cmd.length != 3) {
			System.out.println("Nombre d'arguments incorrectes.");
			System.out.println("Taper 'h -s' pour obtenir de l'aide");
		}
		else {
			Vector liste = new Vector();
			int compte = 0;
			for (int i=1; i<cat.size(); i++) {
				if (((Fiche)cat.elementAt(i)).nom.compareTo(cmd[2]) == 0) {
					liste.addElement(new Integer(i));
					compte ++;
					System.out.print(compte + "- ");
					((Fiche)cat.elementAt(i)).affiche();
				}
			}
			options(liste);
		}
    }

    private static void recherchePrenom (String [] cmd) {
		if (cmd.length != 3) {
			System.out.println("Nombre d'arguments incorrectes.");
			System.out.println("Taper 'h -s' pour obtenir de l'aide");
		}
		else {
			Vector liste = new Vector();
			int compte = 0;
			for (int i=1; i<cat.size(); i++) {
				if (((Fiche)cat.elementAt(i)).prenom.compareTo(cmd[2]) == 0) {
					liste.addElement(new Integer(i));
					compte ++;
					System.out.print(compte + "- ");
					((Fiche)cat.elementAt(i)).affiche();
				}
			}
			options(liste);
		}
    }

    private static void rechercheId (String [] cmd) {
		if (cmd.length != 3) {
			System.out.println("Nombre d'arguments incorrectes.");
			System.out.println("Taper 'h -s' pour obtenir de l'aide");
		}
		else {
			try {
				Vector liste = new Vector();
				Integer _id = new Integer(cmd[2]);
				int id = _id.intValue();
				int compte = 0;
				for (int i=1; i<cat.size(); i++) {
					if (((Fiche)cat.elementAt(i)).id == id) {
						liste.addElement(new Integer(i));
						compte ++;
						System.out.print(compte + "- ");
						((Fiche)cat.elementAt(i)).affiche();
					}
				}
				options(liste);
			}
			catch (NumberFormatException e) {
				System.out.println("Le dernier argument doit etre un entier.");
				System.out.println("Taper 'h -s' pour obtenir de l'aide");
			}
		}
    }

    private static void rechercheDate (String [] cmd) {
		if (cmd.length != 8) {
			System.out.println("Nombre d'arguments incorrectes.");
			System.out.println("Taper 'h -s' pour obtenir de l'aide");
		}
		else {
			try {
				Vector liste = new Vector();
				int compte = 0;
				Fiche entree;
				int jour = (new Integer(cmd[2])).intValue();
				int mois = (new Integer(cmd[3])).intValue() - 1;
				int annee = (new Integer(cmd[4])).intValue() - 1900;
				Date date1 = new Date(annee, mois, jour, 0, 0, 0);
				if (date1.getDate()!=jour || date1.getMonth()!=mois){
					System.out.print("La date " + jour + "/" + (mois+1) + "/");
					System.out.println((annee+1900) + " n'existe pas.");
				}
				else {
					jour = (new Integer(cmd[5])).intValue();
					mois = (new Integer(cmd[6])).intValue() - 1;
					annee = (new Integer(cmd[7])).intValue() - 1900;
					Date date2 = new Date(annee, mois, jour, 0, 0, 0);
					if (date2.getDate()!=jour || date2.getMonth()!=mois) {
						System.out.print("La date " + jour + "/" + (mois+1) + "/");
						System.out.println((annee+1900) + " n'existe pas.");
					}
					else {
						if (date1.before(date2)) {
							for (int i=1; i<cat.size(); i++) {
								entree = (Fiche) cat.elementAt(i);
								if ( entree.date.compareTo(date2)<=0 && entree.date.compareTo(date1)>=0 ) {
									liste.addElement(new Integer(i));
									compte ++;
									System.out.print(compte + "- ");
									entree.affiche();
								}
							}
						}
						else {
							for (int i=1; i<cat.size(); i++) {
								entree = (Fiche) cat.elementAt(i);
								if ( entree.date.compareTo(date2)>=0 && entree.date.compareTo(date1)<=0 ) {
									liste.addElement(new Integer(i));
									compte ++;
									System.out.print(compte + "- ");
									entree.affiche();
								}
							}
						}
						options(liste);
					}
				}
			}
			catch (NumberFormatException e) {
				System.out.println("Les 2 dates doivent etre donnees sous forme d'entiers separes par des espaces.");
				System.out.println("Taper 'h -s' pour obtenir de l'aide");
			}
		}
    }

	private static void options (Vector liste) {
		boolean done;
		String sTemp;
		int[] tabInt;
		if (liste.size() == 0)
			System.out.println("Aucune entree dans le catalogue ne correspond a ce critere");
		else {
			System.out.println("Voulez-vous modifier ou supprimer l'une de ces entrees ?");
			done = false;
			while (!done){
				System.out.print(">[n=no,m=modifie,d=delete]> ");
				sTemp  = StdIn.readWord();
				if (sTemp.compareTo("d")==0 || sTemp.compareTo("delete")==0){
					System.out.println("Que voulez-vous supprimer ?");
					System.out.println("Entrez un ou plusieurs numeros de ligne separes par des espaces");
					System.out.print(">[to delete]> ");
					tabInt = StdIn.readLineInt();
					if (tabInt != null) { //il n'y a que des chiffres ds la saisie
						int pos;
						// On balaille tous les numeros saisis
						for (int j=0; j<tabInt.length; j++) {
							// On regarde si les num coorespondent a des entrees proposees
							if (tabInt[j]>0 && tabInt[j]<=liste.size()) {
								pos = ((Integer)liste.elementAt(tabInt[j]-1)).intValue();
								/* Quand on supprime un element du catalogue cat, la position de tous les 
								   elements qui se trouvaient apres lui diminue de 1. On en tient 
								   compte ici. */
								for (int k=0; k<j; k++) {
									if (tabInt[k] < tabInt[j] && tabInt[k]>0)
										pos--;
									else if (tabInt[k] == tabInt[j]) { // L'element a deja ete supprime
										pos = -1; //on signal qu'il ne faut rien supprimer
										tabInt[j] = -1; //on supprime ce num redondant
									}
								}
								if (pos != -1)
									supprimer(pos);
								}
							else {
								/* On ne prend pas en compte les numeros qui ne 
								   correspondent a rien. On se contente de le signaler. */
								System.out.println(tabInt[j] + " ne correspond a aucun entree");
							}
						}
					}
					else {
						/* Ne fait rien si la liste des fichiers a supprimer est erronee
						   par ex si elle ne contient pas que des chiffres.
						   On repart a l'invite de commande de plus bas niveau. */
						System.out.println("Liste de fichiers a supprimer erronee.");
					}
					done = true;
				}
				else if (sTemp.compareTo("n")==0 || sTemp.compareTo("no")==0) {
					done = true;
				}
				else if (sTemp.compareTo("m")==0 || sTemp.compareTo("modifie")==0) {
					System.out.println("Que voulez-vous modifier ?");
					System.out.println("Entrez un ou plusieurs numeros de ligne separes par des espaces");
					System.out.print(">[to modifie]> ");
					tabInt = StdIn.readLineInt();
					if (tabInt != null) { //il n'y a que des chiffres ds la saisie
						// On balaille tous les numeros saisis
						for (int j=0; j<tabInt.length; j++) {
							// On regarde si les num coorespondent a des entrees proposees
							if (tabInt[j]>0 && tabInt[j]<=liste.size()) {
								// Rem: on modifie tous les num saisis autant de fois qu'ils apparaissent
								modifier(((Integer)liste.elementAt(tabInt[j]-1)).intValue());
							}
							else {
								/* On ne prend pas en compte les numeros qui ne 
								   correspondent a rien. On se contente de le signaler. */
								System.out.println(tabInt[j] + " ne correspond a aucun entree");
							}
						}
					}
					else {
						/* Ne fait rien si la liste des fichiers a modifier est erronee
						   par ex si elle ne contient pas que des chiffres.
						   On repart a l'invite de commande de plus bas niveau. */
						System.out.println("Liste de fichiers a modifier erronee.");
					}
					done = true;
				}
			}
		}
    }

   // Supprime de cat l'entree a la position pos
    private static void supprimer (int pos) {
	Fiche entree = (Fiche) cat.elementAt(pos);
	int id = entree.id;
	try {
	    if ( id < ((Fiche)cat.elementAt(0)).id )
		((Fiche)cat.elementAt(0)).id = id;
	    cat.remove(pos);
	    // Si il y a une erreur lors de la suppression, ce qui suit n'est pas execute
	    modif = true;
	    System.out.println("[" + entree + "] SUPPRIME !");
	    entree = null;
	}
	catch (ArrayIndexOutOfBoundsException e) {
	}
    }

    private static void modifier (int pos) {
		modif = true;
		System.out.println("modifier " + pos);
    }

    // Ajoute une nouvelle entree a cat
    private static void ajouter (String[] cmd) {
	System.out.println("Nouvelle entree");
	boolean done = false;
	int [] tabInt;
	String sTemp;
	// Le nom
	System.out.println("Entrer le nom entre '\"' si il comporte des espaces");
	System.out.print(">[name]> ");
	entree.nom = StdIn.readWord();
	// Le prenom
	System.out.println("Entrer le prenom entre '\"' si il comporte des espaces");
	System.out.print(">[firstname]> ");
	entree.prenom = StdIn.readWord();
	// La date
	System.out.println("Entrer la date dans le format: jour mois annee");
	while (!done) {
	    System.out.print(">[date]> ");
	    tabInt = StdIn.readLineInt();
	    if (tabInt != null && tabInt.length == 3) { // L'utilisateur a reellement saisi une date
		Date date = new Date(tabInt[2],tabInt[1],tabInt[0],0,0,0);
		if (date.getDate()!=tabInt[0] || date.getMonth()!=tabInt[1]) // Date inexistante
		    System.out.println("Cette date n'existe pas.");
		else {
		    entree.date = date;
		    done = true;
		}
	    }
	}
	done = false;
	// La voiture
	System.out.println("Entrer le nom de la voiture entre '\"' si il comporte des espaces");
	System.out.print(">[car]> ");
	entree.nom = StdIn.readWord();
	// Le prix
	System.out.println("Entrer le prix de l'achat (sans le symbole F)");
	while (!done) {
	    System.out.print(">[prix]> ");
	    if ((entree.prix = StdIn.readWordDouble()) != -1)
		done = true;
	}
	done = false;
	// Entre dans le catalogue cat
	System.out.println("Ajouter [" + entree + "] ?");
	while (!done) {
	    System.out.print(">[y=yes,n=no]> ");
	    sTemp = readWord();
	    if (sTemp.compareTo("n")==0 || sTemp.compareTo("no")==0) {
		done = true;
	    }
	    else if (sTemp.compareTo("y")==0 || sTemp.compareTo("yes")==0) {
		done = true;
		modif = true;
		// On regarde si ce client ne possede deja pas un numero
		if ((entree.id=clientExiste(entree.nom,entree.prenom)) < 1) {
		    entree.id = ((Fiche) cat.elementAt(0)).id;
		    cat.addElement(entree);
		    ((Fiche) cat.elementAt(0)).id = firstNumFree(((Fiche) cat.elementAt(0)).id);
		}
		else {
		    cat.addElement(entree);
		}
	    }
	}
	System.out.println("[" + entree + "] AJOUTE");
    }

    // Retourne le premier num de client libre
    private static int firstNumFree (int min) {
	min++;
	boolean done = false;
	while (!done) {
	    done = true;
	    for (int i=1; i<cat.size()-1; i++) {
		if (((Fiche) cat.elementAt(i)).id == min) {
		    done = false;
		    min++;
		}
	    }
	}
	System.out.println("Nouveau min=" + min);
	return min;
    }

    // Regarde si le client 'nom prenom' existe deja
    // retour son id si il existe ou 0 sinon
    private static int clientExiste (String nom, String prenom) {
	for (int i=0; i<cat.size(); i++) {
	    if (((Fiche) cat.elementAt(i)).nom.compareTo(nom)==0 && ((Fiche) cat.elementAt(i)).prenom.compareTo(prenom)==0 ) 
		return ((Fiche) cat.elementAt(i)).id;
	}
	return 0;
    }

     private static void sauver (String [] cmd) {
		modif = false;
		System.out.println("sauver");
    }
}
