import java.io.*;
import java.util.*;

class Lecture {
    protected StreamTokenizer stoken;
    protected BufferedReader flot;
    
    // Constructeurs
    public Lecture (String nom) { // A partir d'un fichier
		try {
			FileInputStream  fic1;
			fic1 = new FileInputStream (nom);
			flot = new BufferedReader(new InputStreamReader(fic1));
			stoken = new StreamTokenizer(flot);
			stoken.eolIsSignificant(false);
		}
		catch (FileNotFoundException e){
			System.out.println("Le fichier " + nom + " n'existe pas !");
			// Cela ne devrait jamais arriver car on verifie l'existance du fichier avant 
			// creation de l'objet Lecture
			System.exit(0);
		}
		catch (Exception e) {
			System.out.println("erreur ouverture fichier");
			e.printStackTrace();
		}
    } 

    // Lit le StreamTokenizer et stocke ce qui est lu dans un Vector
    public Vector read () throws IOException{
		Vector vect = new Vector();
		vect.addElement(premiereFiche());
		while (!isEOF())
			vect.addElement(ficheSuivante());
		return vect;
	}
		
	// Lit la 1ere ligne du fichier catalogue et retourne une fiche avec le 1er num de client libre
	protected Object premiereFiche () throws IOException{
		boolean errorFormat = false;
		Fiche entree = new Fiche();
		// Sur la 1ere ligne on trouve le 1er num de client non attribue
		stoken.nextToken();
		if (stoken.ttype == StreamTokenizer.TT_NUMBER)
			entree.id = (int) stoken.nval;
		else
			errorFormat = true;
		if (errorFormat) {
			System.out.println("Le format du fichier texte est errone.");
			System.out.println("Impossible de retrouver les informations de ce catalogue.");
			System.exit(0);
		}
		stoken.nextToken();
		return entree;
    }

    // Lit une ligne du fichier catalogue en verifie sa structure et retourne une Fiche
    // Ne peut etre utilise qu'apres premiereFiche()
    protected Object ficheSuivante () throws IOException{
		Date date = new Date(0, 0, 0, 0, 0, 0);
		boolean errorFormat = false;
		Fiche entree = new Fiche();
		// Champ num de client
		if (stoken.ttype == StreamTokenizer.TT_NUMBER)
			entree.id = (int) stoken.nval;
		else {
			errorFormat = true;
			System.out.println("erreur id");
		}
		// Champ nom de client
		stoken.nextToken();
		if (stoken.ttype == StreamTokenizer.TT_WORD || stoken.ttype == '"')
			entree.nom = stoken.sval;
		else {
			errorFormat = true;
			System.out.println("erreur nom");
		}
		// Champ prenom de client
		stoken.nextToken();
		if (stoken.ttype == StreamTokenizer.TT_WORD || stoken.ttype == '"')
			entree.prenom = stoken.sval;
		else {
			errorFormat = true;
			System.out.println("erreur prenom");
		}
		// Jour de l'achat
		stoken.nextToken();
		if (stoken.ttype == StreamTokenizer.TT_NUMBER)
			date.setDate((int) stoken.nval);
		else {
			errorFormat = true;
			System.out.println("erreur jour");
		}
		// Mois de l'achat
		stoken.nextToken();
		if (stoken.ttype == StreamTokenizer.TT_NUMBER)
			date.setMonth(((int) stoken.nval)-1);
		else {
			errorFormat = true;
			System.out.println("erreur mois");
		}
		// Annee de l'achat
		stoken.nextToken();
		if (stoken.ttype == StreamTokenizer.TT_NUMBER)
			date.setYear(((int) stoken.nval)-1900);
		else {
			errorFormat = true;
			System.out.println("erreur annee");
		}
		entree.date = date;
		// Champ nom de la voiture
		stoken.nextToken();
		if (stoken.ttype == StreamTokenizer.TT_WORD || stoken.ttype == '"')
			entree.voiture = stoken.sval;
		else {
			errorFormat = true;
			System.out.println("erreur voiture");
		}
		// Prix
		stoken.nextToken();
		if (stoken.ttype == StreamTokenizer.TT_NUMBER)
			entree.prix = stoken.nval;
		else {
			errorFormat = true;
			System.out.println("erreur prix");
		}

		if (errorFormat) {
			System.out.println("Le format du fichier texte est errone.");
			System.out.println("Impossible de retrouver les informations de ce catalogue.");
			System.exit(0);
		}
		stoken.nextToken();
		return entree;
    }

    // Lit chq marque du StreamTokenizer une par une et la retourne en String
    protected String lireSuivant () throws IOException{
		stoken.nextToken();
		switch (stoken.ttype) {
		case StreamTokenizer.TT_WORD: 
		case '"':
			return stoken.sval;
		case StreamTokenizer.TT_NUMBER:
			String s = "" + stoken.nval;
			return s;
		default:
			return null;
		}
    }

    // Teste si la marque lue est du type EOF
    protected boolean isEOF () {
		return (stoken.ttype == StreamTokenizer.TT_EOF);
    }
    
    // Teste si la marque lue est du type EOL
    protected boolean isEOL () {
		return (stoken.ttype == StreamTokenizer.TT_EOL);
    }

    public void ferme() throws IOException{
		flot.close();
    }
}
