import java.util.*;
import java.io.*;
import java.lang.*;

class StdIn {
    // Retourne la premiere lettre de l'entree standard 
    // (et la supprime de l'entree standard en meme temps)
    public static char readChar () {
		int charInt = -9999;
		try {
			charInt = System.in.read();
		}
		catch (IOException e) {
			System.out.println("Impossible d lire sur l'entree standard !");
			e.printStackTrace();
			System.exit(0);
		}
		return (char) charInt;
    }

    // Retourne le premier mot de l'entree standard
    // (et supprime le reste de la ligne de l'entree standard)
    public static String readWord () {
		// Recupere le 1er mot
		String result = "";
		char next = readChar();
		while (Character.isWhitespace(next)) 
			next = readChar();
		/* Si le nom est compose d'espaces, il doit etre entoure de 2 '"' 
		   le dernier etant suivi d'un caractere non imprimable ou d'un espace
		   Si il y a un '"' au debut mais pas de 2eme alors tous les mots
		   derriers '"' sont concatene ensemble. */
		if (next == '"') {
			next = readChar();
			while (next != '\r' || next != '\n'){
				if (next != '"') {
					result = result + next;
					next = readChar();
				}
				else {
					next = readChar();
					if (!(Character.isWhitespace(next)))
						result = result + '"' + next;
					else
						break;
				}
			}
		}
		else {
			while (!(Character.isWhitespace(next))) {
				result = result + next;
				next = readChar();
			}
		}
		// Supprime ce qui reste sur cette ligne
		while (next != '\n')
			next = readChar();
		// Retourne le 1er mot
		return result;
    }

    // Retourne la ligne de l'entree standard sous forme de tableau de String
    public static String[] readLine () {
		// Recupere la ligne sur l'entree standard sous forme de String
		char nextChar;
		String ligne = "";
		boolean isEOL = false;
		while (!isEOL) {
			nextChar =readChar();
			if (nextChar == '\n')
				isEOL = true;
			else if (nextChar == '\r') {
				/* Sur certains sytem, '\n' est prcd de '\r' qu'il ne faut pas crire
				   dans ligne. */
			}
			else
				ligne = ligne + nextChar;
		}
		// Traite cette ligne pour la mettre sous forme de tableau de String
		StringTokenizer sToken = new StringTokenizer(ligne);
		int compte = sToken.countTokens();
		String[] result = new String[compte];
		int i,j;
		for (i=0,j=0 ; i<compte ; i++,j++) {
			result[j] = sToken.nextToken();
			if (result[j].startsWith("\"")) { // il faut trait le cas des chaines entre " "
				result[j] = result[j].substring(1);
				while (!result[j].endsWith("\"") && i+1<compte) {
					result[j] = result[j] + " " + sToken.nextToken();
					i++;
				}
				if (result[j].endsWith("\""))
					result[j] = result[j].substring(0,result[j].length()-1);
			}
		}
		if (i>j) { // on retourne un tableau de taille minimal
			String[] temp = new String[j];
			System.arraycopy(result,0,temp,0,j);
			return temp;
		}
		return result;
    }

    public static int[] readLineInt () {
		// Recupere la ligne sur l'entree standard sous forme de String
		char nextChar;
		String ligne = "";
		boolean isEOL = false;
		while (!isEOL) {
			nextChar =readChar();
			if (nextChar == '\n')
				isEOL = true;
			else if (nextChar == '\r') {
				/* Sur certains sytem, '\n' est prcd de '\r' qu'il ne faut pas crire
				   dans ligne. */
			}
			else
				ligne = ligne + nextChar;
		}
		// Traite cette ligne pour la mettre sous forme de tableau de String
		StringTokenizer sToken = new StringTokenizer(ligne);
		int compte = sToken.countTokens();
		int[] result = new int[compte];
		try {
			for (int i=0; i<compte; i++) 
				result[i] = (new Integer(sToken.nextToken())).intValue();
		}
		catch (NumberFormatException e) {
			return null;
		}
		return result;
    }

    public static double readWordDouble () {
	String s = readWord();
	try {
	    double result = (new Double(s)).doubleValue();
	    return result;
	}
	catch (NumberFormatException e) {
	    return -1;
	}
    }

}
