import javax.swing.*;
import javax.swing.text.*; 
import java.awt.*;
import java.awt.event.*;
import java.util.*;

/**********************************************************************************
  Cette classe est une boite de dialogue destinee a saisir les informations pour
  modifier une fiche. Ceci ressemble bcp a creer une nouvelle fiche, c'est pourquoi
  elle heirte de NewFicheDialog.
  Le type de ces informations est verifie avant de fermer la boite et d'inserer
  cette nouvelle fiche ds le catalogue.
***********************************************************************************/

class ModifFicheDialog extends NewFicheDialog {
	private ModifFicheDialog () {} // Constructeur interdit

    public ModifFicheDialog (Fiche fic, Frame own, boolean modal) {
		super(fic, own, modal);
		// Modification du texte d'introduction
		introTxt.setText("Modifiez les champs suivants, puis validez.");
		// Remplissage des champs par leur ancienne valeur
		nomField.setText(fic.nom);
		prenomField.setText(fic.prenom);
		jourField.setText(Integer.toString(fic.date.getDate()));
		moisField.setText(Integer.toString(fic.date.getMonth()+1));
		anneeField.setText(Integer.toString(fic.date.getYear()+1900));
		voitureField.setText(fic.voiture);
		prixField.setText(Double.toString(fic.prix));
		// On interdit de changer le nom ou le prenom de la fiche
		nomField.setEditable(false);
		prenomField.setEditable(false);
    }
}
