import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;

/************************************************************************************
  Cette classe est un filtre pour la boite de dialogue gerant l'ouverture de fichier.
  Elle interdit a l'utilisateur d'utiliser des fichiers qu'il ne peut pas lire.
*************************************************************************************/

public class RFilter extends FileFilter {
    
    // Definie les fichiers valides
    public boolean accept(File f) {
		if (f.isDirectory()) { // Accepte les repertoires
			return true;
		}
		if (f.isFile()) {
			if (f.canRead()) {
				return true; // Accepte les fichiers reguliers lisibles
			}
		}
		return false;
    }
    
    // La description du filtre
    public String getDescription() {
        return "Au moins accessible en lecture";
    }
}
