import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;

/******************************************************************************
  Cette classe est un filtre pour les boites de dialogue gerant la fermeture et
  l'ouverture de fichier.
  Elle interdit a l'utilisateur d'utiliser des fichiers sur lesquels il ne peut
  pas lire ET ecrire.
*******************************************************************************/
 
public class RWFilter extends FileFilter {
    
    // Definie les fichiers valides
    public boolean accept(File f) {
        if (f.isDirectory()) { // Accepte les repertoires
            return true;
        }
		if (f.isFile()) {
			if (f.canRead()) {
				if (f.canWrite()) {
					return true; /* Accepte les fichiers reguliers 
									accessible en lecture / ecriture */
				}
			}
		}
        return false;
    }
    
    // La description du filtre
    public String getDescription() {
        return "Accessible en lecture-ecriture";
    }
}
