import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;

/*************************************************************************************
  Cette classe est un filtre pour la boite de dialogue gerant la fermeture de fichier.
  Elle interdit a l'utilisateur d'utiliser des fichiers sur lesquels il ne peut pas 
  ecrire.
**************************************************************************************/

public class WFilter extends FileFilter {
    
    // Definie les fichiers valides
    public boolean accept (File f) {
        if (f.isDirectory()) { // Accepte les repertoires
            return true;
        }
		if (f.isFile()) {
			if (f.canWrite()) {
				return true; // Accepte les fichiers reguliers accessible en ecriture
			}
		}
        return false;
    }
    
    // La description du filtre
    public String getDescription () {
        return "Au moins accessible en ecriture";
    }
}
